package cc.toph.simplycompat.config;

import cc.toph.simplycompat.SimplyCompat;

public class Config {
  private SimpleConfig config;
  private final ConfigProvider provider;

  public Config(ConfigProvider provider) {
    this.provider = provider;
    config = SimpleConfig.of(provider.getNamespace()).provider(provider).request();
  }

  public void register() {
    config.update();
  }

  // Overloaded registerProp for float
  public float registerProp(String key, float defaultValue, String comment) {
    provider.addKeyValuePair(key, defaultValue, comment);
    // Cast needed because getOrDefault for numbers returns double
    return (float) config.getOrDefault(key, defaultValue);
  }

  // Overloaded registerProp for int
  public int registerProp(String key, int defaultValue, String comment) {
    provider.addKeyValuePair(key, defaultValue, comment);
    return config.getOrDefault(key, defaultValue);
  }

  // Overloaded registerProp for double
  public double registerProp(String key, double defaultValue, String comment) {
    provider.addKeyValuePair(key, defaultValue, comment);
    return config.getOrDefault(key, defaultValue);
  }

  // Overloaded registerProp for String
  public String registerProp(String key, String defaultValue, String comment) {
    provider.addKeyValuePair(key, defaultValue, comment);
    return config.getOrDefault(key, defaultValue);
  }

  // Overloaded registerProp for boolean
  public boolean registerProp(String key, boolean defaultValue, String comment) {
    provider.addKeyValuePair(key, defaultValue, comment);
    return config.getOrDefault(key, defaultValue);
  }
}