package cc.toph.simplycompat.registry;

import cc.toph.simplycompat.SimplyCompat;
import cc.toph.simplycompat.config.Config;
import cc.toph.simplycompat.config.ConfigProvider;

public class ConfigRegistry {
  public static final class WEAPON_ATTRIBUTES {

    public static float COPPER;
    public static float STEEL;

    public static final ConfigProvider PROVIDER = new ConfigProvider("weapon_attributes");

    public static void register() {
      Config common = new Config(PROVIDER);

      COPPER = common.registerProp(
              "copper_damageModifier",
              3.0f,
              "Copper Damage Modifier"
      );

      STEEL = common.registerProp(
              "steel_damageModifier",
              5.0f,
              "Steel Damage Modifier"
      );

      common.register();
    }
  }

  public static void registerConfigs() {
    WEAPON_ATTRIBUTES.register();
  }
}
